%Slavery

%%
%DATA Organizing & Cleaning

%Create new ordered pair_id's
    pair_id_new = zeros(size(ID,1)/2,1);
    for i=1:size(ID,1)/2
        pair_id_new(i)=i;
    end
        
    pair_id_new = [pair_id_new; pair_id_new];
    pair_id_new = sort(pair_id_new,1);          %This vector has new pair_id lables
        

    %Find observations with missing values
    missing = zeros(size(DATA,1),1);
    for i=1:size(DATA,1)
        %for j=1:size(DATA,2)
         for j=1:33
            if isnan(DATA(i,j))== 1
                missing(i,1) = 1;               %missing contains info of observations with missings
            end
         
        end
       
    end

    
    %Produce info of pairs of observations with missings to also drop
    drop_codes = pair_id_new(missing==1);       %drop_codes is vector of pair codes to drop
    
    
    %Create vector of observations to drop
 
    drop = zeros(size(pair_id_new,1),1);
    for i=1:size(drop_codes,1)
        for j=1:size(pair_id_new,1)
            if drop_codes(i,1)==pair_id_new(j,1)
                drop(j,1)=1;                    %drop contains info of observations to drop
            end
         
        end
        
    end
       
    %Drop observations
    ID = ID(drop==0,:);                         %drop observations
    DATA = DATA(drop==0,:);        
            
   %Now ID and DATA contain all the observations for estimation
   
   %Create the new pair_id's again, after having droped observations
   
    pair_id_new = zeros(size(ID,1)/2,1);
    for i=1:size(ID,1)/2
        pair_id_new(i)=i;
       
    end
        
    pair_id_new = [pair_id_new; pair_id_new];
    pair_id_new = sort(pair_id_new,1);          %This vector has new pair_id lables      
            
    %Cleaning 
    clear i j missing drop_codes drop
    
    
    %Create variables for estimation

    code = ID(:,1);
    pair_id = pair_id_new;
    CLUSTER_DUMMIES = ID(:,4:45);
    drop_cl = sum(CLUSTER_DUMMIES);
    CLUSTER_DUMMIES = CLUSTER_DUMMIES(:,drop_cl~=0);
    cluster_id = sum((CLUSTER_DUMMIES*diag(1:1:size(CLUSTER_DUMMIES,2)))')';
    PAIR_DUMMIES = ID(:,46:251);
    DEPT_DUMMIES = ID(:,252:283);
    unique = ID(:,284);
    
    
    %Exclude dummies that are all zero
    clean = sum(CLUSTER_DUMMIES);
    CLUSTER_DUMMIES = CLUSTER_DUMMIES(:,clean~=0);
    
    clean = sum(PAIR_DUMMIES);
    PAIR_DUMMIES = PAIR_DUMMIES(:,clean~=0);
    
    clean = sum(DEPT_DUMMIES);
    DEPT_DUMMIES = DEPT_DUMMIES(:,clean~=0);
    
    Y = DATA(:,1);                                                                                               %Outcome variable
    S = DATA(:,2:4);                                                                                             %Slavery data col 1= intensity, col 2=dummy, col 3=capped at 10%  
    G = DATA(:,5);                                                                                               %Gold mine dummy (instrument)
    COVARIATES_LINEAR = [DATA(:,6) DATA(:,10) DATA(:,14) DATA(:,18) DATA(:,22) DATA(:,26) DATA(:,30:33)];        %Linear Controls
    COVARIATES_POLY = DATA(:,6:33);                                                                              %Polynomial controls
                                  
    obs = size(Y,1);                                                                                             %Number of observations
    num_clusters = size(CLUSTER_DUMMIES,2);                                                                      %Number of clusters
    num_pairs = size(PAIR_DUMMIES,2);                                                                            %Number of neighbor pairs
    num_depts = size(DEPT_DUMMIES,2);                                                                            %Number of departments
    num_pairs_per_cluster = (G'*CLUSTER_DUMMIES)';                                                               %Number of pairs in each cluster
    gold_codes = [((((code.*G)'*CLUSTER_DUMMIES))./num_pairs_per_cluster')' [1:1:num_clusters]'];                %Codes of Gold mine municipalities, and their cluster

    R = [code CLUSTER_DUMMIES];                                                                                                                                                                                                                                                                                                          
    R = R(G==0,:);
    R = sortrows(R);
    [non_gold_codes(:,1) non_gold_codes(:,2)] = count_unique(R(:,1));                                            %Codes of Non Gold mine municipalities, and the number of clusters they belong to
    
    A = R';
    AA = [1:1:size(CLUSTER_DUMMIES,2)]';
    
   
    %AAA = zeros();
    for i=1:size(A,2)
        AAA(:,i) = A(2:size(A,1),i).*AA;
       
    end
    
    non_gold_cluster_codes = [A(1,:); AAA]; 
    non_gold_cluster_codes = sortrows([non_gold_cluster_codes(1,:); sum(non_gold_cluster_codes) - non_gold_cluster_codes(1,:)]');         %List of codes of non gold mine municipalities and the clusters they belong to
    
    clear clean A AA AAA

    
%%
 %NEIGHBORHOOD FIXED EFFECTS
 
 %7. Neighborhood Fixed Effects OLS
        %Only Department Dummies
        X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1)];

        X_short = X(unique==1,:);
        Y_short = Y(unique==1,:);
        
        betas_NE_OLS_SlaveDummy_dept = (X_short'*X_short)\(X_short'*Y_short);

        eps = Y_short - X_short*betas_NE_OLS_SlaveDummy_dept;
        eps_2 = eps.*eps;
        
        OMEGA = zeros(size(X_short,2));
        for i=1:obs_short
            OMEGA = OMEGA + eps_2(i,1)*(X_short(i,:)'*X_short(i,:));            %Matrix for Robust Standard Errors
        end
                         
        std_betas_NE_OLS_SlaveDummy_dept = sqrt(diag((obs_short/(obs_short-size(X_short,2)))*((X_short'*X_short)\OMEGA/(X_short'*X_short))));
    
        R_sq = 1 - ((sum(eps_2)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
        Rsq(1,19)= R_sq;
        
        %With Geographic controls OLS
        X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1) COVARIATES_LINEAR];

        X_short = X(unique==1,:);
        Y_short = Y(unique==1,:);
        
        betas_NE_OLS_SlaveDummy_geogr = (X_short'*X_short)\(X_short'*Y_short);

        eps = Y_short - X_short*betas_NE_OLS_SlaveDummy_geogr;
        eps_2 = eps.*eps;
        
        OMEGA = zeros(size(X_short,2));
        for i=1:obs_short
            OMEGA = OMEGA + eps_2(i,1)*(X_short(i,:)'*X_short(i,:));            %Matrix for Robust Standard Errors
        end
                         
        std_betas_NE_OLS_SlaveDummy_geogr = sqrt(diag((obs_short/(obs_short-size(X_short,2)))*((X_short'*X_short)\OMEGA/(X_short'*X_short))));
        
        R_sq = 1 - ((sum(eps_2)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
        Rsq(1,21)= R_sq;
       
        %With Polynomial Geographic controls OLS
        X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1) COVARIATES_POLY];

        X_short = X(unique==1,:);
        Y_short = Y(unique==1,:);
                
        betas_NE_OLS_SlaveDummy_poly = (X_short'*X_short)\(X_short'*Y_short);

        eps = Y_short - X_short*betas_NE_OLS_SlaveDummy_poly;
        eps_2 = eps.*eps;
        
        OMEGA = zeros(size(X_short,2));
        for i=1:obs_short
            OMEGA = OMEGA + eps_2(i,1)*(X_short(i,:)'*X_short(i,:));            %Matrix for Robust Standard Errors
        end
                         
        std_betas_NE_OLS_SlaveDummy_poly = sqrt(diag((obs_short/(obs_short-size(X_short,2)))*((X_short'*X_short)\OMEGA/(X_short'*X_short))));

        R_sq = 1 - ((sum(eps_2)/sum(((Y_short - (sum(Y_short)/obs_short)).^2))));
        
        Rsq(1,23)= R_sq;
    
     
 
 %8. Neighborhood Fixed Effects IV                   
        %Only Department Dummies
        X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1)];
        Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1)];
        
        X_short = X(unique==1,:);
        Z_short = Z(unique==1,:);
        Y_short = Y(unique==1,:);
        
        clean = sum(X_short);
        X_short = X_short(:,clean~=0);
        clean = sum(Z_short);
        Z_short = Z_short(:,clean~=0);
                
        Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
        X_hat_short = Pz*X_short;   
        
              
            %Second Stage
            betas_NE_IV_SlaveDummy_dept = (X_hat_short'*X_hat_short)\(X_hat_short'*Y_short);

            eps = Y_short - X_short*betas_NE_IV_SlaveDummy_dept;
            eps_2 = (eps.*eps);
            
            OMEGA = zeros(size(X_short,2));
            for i=1:obs_short
              OMEGA = OMEGA + eps_2(i,1)*(X_hat_short(i,:)'*X_hat_short(i,:));            %Matrix for Robust Standard Errors
            end
                         
            std_betas_NE_IV_SlaveDummy_dept = sqrt(diag((obs_short/(obs_short-size(X_short,2)))*((X_hat_short'*X_hat_short)\(OMEGA)/(X_hat_short'*X_hat_short))));
        
            %First Stage
            betas_1st_NE_IV_SlaveDummy_dept = (Z_short'*Z_short)\(Z_short'*X_short(:,2));

            eps = X_short(:,2) - Z_short*betas_1st_NE_IV_SlaveDummy_dept;
            eps_2 = eps.*eps;
        
            OMEGA = zeros(size(Z_short,2));
            for i=1:obs_short
              OMEGA = OMEGA + eps_2(i,1)*(Z_short(i,:)'*Z_short(i,:));            %Matrix for Robust Standard Errors
            end

            std_betas_1st_NE_IV_SlaveDummy_dept = sqrt(diag((obs_short/(obs_short-size(Z_short,2)))*((Z_short'*Z_short)\OMEGA/(Z_short'*Z_short))));

            R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
            Rsq(1,20)= R_sq;
            
             
        %With Geographic Controls IV
        X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1) COVARIATES_LINEAR];    
        Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1) COVARIATES_LINEAR];
        
        X_short = X(unique==1,:);
        Z_short = Z(unique==1,:);
        Y_short = Y(unique==1,:);
        
        clean = sum(X_short);
        X_short = X_short(:,clean~=0);
        clean = sum(Z_short);
        Z_short = Z_short(:,clean~=0);
                
        Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
        X_hat_short = Pz*X_short;   
        
        
            %Second Stage
            betas_NE_IV_SlaveDummy_geogr = (X_hat_short'*X_hat_short)\(X_hat_short'*Y_short);

            eps = Y_short - X_short*betas_NE_IV_SlaveDummy_geogr;
            eps_2 = eps.*eps;
        
            OMEGA = zeros(size(X_short,2));
            for i=1:obs_short
              OMEGA = OMEGA + eps_2(i,1)*(X_hat_short(i,:)'*X_hat_short(i,:));            %Matrix for Robust Standard Errors
            end
                         
            std_betas_NE_IV_SlaveDummy_geogr = sqrt(diag((obs_short/(obs_short-size(X_short,2)))*((X_hat_short'*X_hat_short)\OMEGA/(X_hat_short'*X_hat_short))));
        
            %First Stage
            betas_1st_NE_IV_SlaveDummy_geogr = (Z_short'*Z_short)\(Z_short'*X_short(:,2));

            eps = X_short(:,2) - Z_short*betas_1st_NE_IV_SlaveDummy_geogr;
            eps_2 = eps.*eps;
        
            OMEGA = zeros(size(Z_short,2));
            for i=1:obs_short
              OMEGA = OMEGA + eps_2(i,1)*(Z_short(i,:)'*Z_short(i,:));            %Matrix for Robust Standard Errors
            end

            std_betas_1st_NE_IV_SlaveDummy_geogr = sqrt(diag((obs_short/(obs_short-size(Z_short,2)))*((Z_short'*Z_short)\OMEGA/(Z_short'*Z_short))));

            R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
            Rsq(1,22)= R_sq;

            
        %With Polynomial Geographic Controls IV
        X = [ones(obs,1) S(:,2) DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1) COVARIATES_POLY];
        Z = [ones(obs,1) G DEPT_DUMMIES(:,1:num_depts-3) CLUSTER_DUMMIES(:,1:num_clusters-1) COVARIATES_POLY];
        
        X_short = X(unique==1,:);
        Z_short = Z(unique==1,:);
        Y_short = Y(unique==1,:);
        
        clean = sum(X_short);
        X_short = X_short(:,clean~=0);
        clean = sum(Z_short);
        Z_short = Z_short(:,clean~=0);
                
        Pz = (Z_short/(Z_short'*Z_short))*Z_short';
        
        X_hat_short = Pz*X_short;   
        
        
            %Second Stage
            betas_NE_IV_SlaveDummy_poly = (X_hat_short'*X_hat_short)\(X_hat_short'*Y_short);

            eps = Y_short - X_short*betas_NE_IV_SlaveDummy_poly;
            eps_2 = eps.*eps;
        
            OMEGA = zeros(size(X_short,2));
            for i=1:obs_short
              OMEGA = OMEGA + eps_2(i,1)*(X_hat_short(i,:)'*X_hat_short(i,:));            %Matrix for Robust Standard Errors
            end
                         
            std_betas_NE_IV_SlaveDummy_poly = sqrt(diag((obs_short/(obs_short-size(X_short,2)))*((X_hat_short'*X_hat_short)\OMEGA/(X_hat_short'*X_hat_short))));
        
            %First Stage
            betas_1st_NE_IV_SlaveDummy_poly = (Z_short'*Z_short)\(Z_short'*X_short(:,2));

            eps = X_short(:,2) - Z_short*betas_1st_NE_IV_SlaveDummy_poly;
            eps_2 = eps.*eps;
        
            OMEGA = zeros(size(Z_short,2));
            for i=1:obs_short
              OMEGA = OMEGA + eps_2(i,1)*(Z_short(i,:)'*Z_short(i,:));                  %Matrix for Robust Standard Errors
            end

            std_betas_1st_NE_IV_SlaveDummy_poly = sqrt(diag((obs_short/(obs_short-size(Z_short,2)))*((Z_short'*Z_short)\OMEGA/(Z_short'*Z_short))));

            R_sq = 1 - ((sum(eps_2)/sum(((X_short(:,2) - (sum(X_short(:,2))/obs_short)).^2))));
        
            Rsq(1,24)= R_sq;
            

            
            
            
            